<?php
/*
 * UPDATE SCRIPT FOR kOOL RELEASE R44
 *
 * Description:
 * Performs necessary update steps from R43 to R44.
 * 
 * Instructions:
 * - Update the source to R44 first
 * - Set the path to your kOOL installation below and run the script on your kOOL server.
 *
 */


/* Settings */

// Set path to your kOOL installation (absolute or relative)
$kOOL_path = '/var/www/kOOL_demo/';

/* End of settings */



// Include ko.inc (and with it database settings from ko-config.php)
$ko_path = $kOOL_path;
require_once($kOOL_path.'inc/ko.inc');



// Correct linked_items for stored reservations
$items = db_select_data('ko_resitem', 'WHERE 1');
foreach($items as $item) {
	db_update_data('ko_reservation', "WHERE `item_id` = '".$item['id']."'", array('linked_items' => $item['linked_items']));
}
unset($items);



// Serialized filter presets for tracking must now be base64 encoded
$trackings = db_select_data('ko_tracking', 'WHERE 1');
foreach($trackings as $tracking) {
	if(strlen($tracking['filter']) == 4 || substr($tracking['filter'], 0, 1) == 'g') continue;
	db_update_data('ko_tracking', "WHERE `id` = '".$tracking['id']."'", array('filter' => 'F'.base64_encode($tracking['filter'])));
}
unset($trackings);



// ko_admin.disabled might have been '0' instead of '' in some cases which would lead to immediate log out in R44
$logins = db_select_data('ko_admin', "WHERE `disabled` = '0'");
foreach($logins as $login) {
	db_update_data('ko_admin', "WHERE `id` = '".$login['id']."'", array('disabled' => ''));
}
unset($logins);




// Update all group datafields' values where checkboxes had a value of 0
$gdfs = db_select_data('ko_groups_datafields', "WHERE `type` = 'checkbox'");
foreach($gdfs as $gdf) {
	db_update_data('ko_groups_datafields_data', "WHERE `datafield_id` = '".$gdf['id']."' AND `value` = '0'", array('value' => ''));
}
unset($gdfs);



//Store ICAL_DESCRIPTION_FIELDS in userprefs if set
if(is_array($ICAL_DESCRIPTION_FIELDS) && sizeof($ICAL_DESCRIPTION_FIELDS) > 0) {
	$logins = db_select_data('ko_admin', 'WHERE 1');
	foreach($logins as $login) {
		ko_save_userpref($login['id'], 'daten_ical_description_fields', implode(',', $ICAL_DESCRIPTION_FIELDS));
	}
}




// Set event group name as events' title
//  Not necessary but might be helpful to prepopulate new title field
/*
$egs = db_select_data('ko_eventgruppen', 'WHERE 1');
$events = db_select_data('ko_event', 'WHERE 1');
foreach($events as $event) {
	db_update_data('ko_event', "WHERE `id` = '".$event['id']."'", array('title' => $egs[$event['eventgruppen_id']]['name']));
}
unset($egs);
unset($events);
*/



// Update names of uploaded images for table ko_leute
//  Only needed if ko_leute has an column holding an image.
//  Then uncomment below code and rename column "picture" if necessary
/*
$people = db_select_data('ko_leute', "WHERE `picture` != ''");
foreach($people as $person) {
	$pic = basename($person['picture']);
	list($prefix, $end) = explode('_', $pic);
	$new = $prefix.'_picture_'.$end;
	rename($BASE_PATH.'my_images/'.$pic, $BASE_PATH.'my_images/'.$new);
	db_update_data('ko_leute', "WHERE `id` = '".$person['id']."'", array('picture' => '/my_images/'.$new));
}
*/
